package es.unican.docencia.y2012.eda.practica2;

/**
 * Clase auxiliar que contiene metodos para realizar busquedas
 * de elementos en vectores
 * @author Pablo Sanchez (p.sanchez@unican.es)
 *          http://personales.unican.es/sanchezbp
 */
public class Buscador {
	
	/**
	 * Devuelve verdadero si el elemento est contenido en el vector, 
	 * falso en caso contrario 
	 * Precondicion: v != null
	 * @param v El vector donde hay que buscar el elemento
	 * @param e El elemento a buscar en el vector
	 * @return Verdadero si el elemento est en el vector, falso en caso contrario
	 */
	public static boolean busquedaLineal(EnteroLento [] v, EnteroLento e) {
		
		int i = 0;
		
		while((i<v.length) && (!(v[i].igual(e)))) {
			i++;
		} // while
		return i<v.length;
	} // busquedaLineal
	
	/**
	 * Devuelve verdadero si el elemento est contenido en el vector, 
	 * falso en caso contrario 
	 * Precondicion: v != null
	 * @param v El vector donde hay que buscar el elemento
	 * @param e El elemento a buscar en el vector
	 * @return Verdadero si el elemento est en el vector, falso en caso contrario
	 */
	public static boolean busquedaBinaria(int [] v, int e) {
		
		// TODO: A ser completado por el alumno
		
		return false;
	}  // busquedaBinaria

} // BusquedaVectores
