package es.unican.docencia.y2012.eda.practica2;

public class EnteroLento {
	
	//------------------------------------------------------//
	//                      Atributos                       //
	//------------------------------------------------------//
	
	// enter
	int number = 0;
	
	//------------------------------------------------------//
	//                    Getters y Setters                 //
	//------------------------------------------------------//
	public int getNumber() {
		return number;
	} //getNumber

	public void setNumber(int number) {
		this.number = number;
	} // setNumber
	
	
	//------------------------------------------------------//
	//                   Metodos Auxiliares                 //
	//------------------------------------------------------//
	
	/**
	 * Funcion que hace que la ejecucion de un programa se
	 * pare el tiempo en ms indicado por el parametro entero
	 * @param tiempo Tiempo en ms que se detiene la ejecucion
	 *               del programa
	 */
	protected void retraso(int tiempo) {
		try {
			Thread.sleep(tiempo);
		} catch (InterruptedException e) {
			System.out.println("Ha habido algun problema la funcion retraso de la " +
					"clase EnteroLento");
			e.printStackTrace();
		} // try
	} // protected

	/**
	 * Devuelve verdadero si el entero lento que recibe la llamada es
	 * igual que el que se pasa como parmetro
	 * @param n El entero largo con el que vamos a comparar el objeto actual
	 * @return Verdadero si el entero lento que recibe la llamada es
	 * igual que el que se pasa como parmetro, falso en caso contrario
	 */
	public boolean igual(EnteroLento n) {
		retraso(1);
		return this.number == n.getNumber();
	} // igual
	
	/**
	 * Devuelve verdadero si el entero lento que recibe la llamada es
	 * menor que el que se pasa como parmetro
	 * @param n El entero largo con el que vamos a comparar el objeto actual
	 * @return Verdadero si el entero lento que recibe la llamada es
	 * menor que el que se pasa como parmetro, es decir n. Falso en caso contrario
	 */
	public boolean menor(EnteroLento n) {
    	retraso(1);
		return this.number < n.getNumber();
	} // igual
	
	/**
	 * Devuelve verdadero si el entero lento que recibe la llamada es
	 * mayor que el que se pasa como parmetro
	 * @param n El entero largo con el que vamos a comparar el objeto actual
	 * @return Verdadero si el entero lento que recibe la llamada es
	 * mayor que el que se pasa como parmetro, es decir n. Falso en caso contrario
	 */
	public boolean mayor(EnteroLento n) {
    	retraso(1);
		return this.number > n.getNumber();
	} // igual

} 
