package es.unican.docencia.y2012.eda.practica2;

/**
 * Clase que sirve para lanzar el programa de prueba para la 
 * prctica sobre anlisis de algoritmos
 * @author Pablo Sanchez (p.sanchez@unican.es)
 * 		   http://personales.unican.es/sanchezbp	
 */
public class Runner {

	/**
	 * Metodo de entrada a la aplicacion
	 * @param args Argumentos de la linea de comandos. Son simplemente ignorados
	 */
	public static void main(String[] args) {
		
		// Vector que voy a utilizar para realizar mi experimento
		EnteroLento [] v = null;
		
		// Genero un ejemplar "aleatorio" para mi experimento
		// de tamao respetable
		v = GeneraVectores.generaVectorOrdenado(10);
		
		// Genero un nmero aleatorio que puede estar o no estar en el vector
		EnteroLento e = GeneraVectores.generaEnteroAleatorio(0,14); 
		
		// Guardo el nmero transcurrido de milisegundos desde 
		// el 1 de Enero de 1970 antes de invocar la  operacion 
		// (por qu desde 01/01/1970? Los de Java sabrn 
		long tInicio = System.currentTimeMillis();
		Buscador.busquedaLineal(v, e);
		// Guardo el nmero transcurrido de milisegundos desde 
		// el 1 de Enero de 1970 despues de invocar la  operacion 
		long tFin = System.currentTimeMillis();
		// El tiempo que ha tardado mi algoritmo es la diferencia entre
		// ambos tiempos
		long tiempoEmpleado = tFin - tInicio;
		// Si: (1) mi computador es bueno; y/o (2)el algoritmo demasiado rpido; 
		//      y/o (3) el tamao del problema demasiado pequeo, lo normal es 
		//		que tarde menos que 1 ms, por lo que el resultado ser 0 ms.
		// Esto significa que debera probar para tamaos ms grandes del problema;
		System.out.println("El algoritmo ha tardado " + tiempoEmpleado + " ms.");
		
		// Si alguien est interesado en ver como se miden tiempos que duren menos de 1ms
		// pueden ver la solucin el el mtodo medir tiempos cortos
		// medirTiemposCortos();
				
	} // main
	
	public static void medirTiemposCortos() {
		
        // Para medir tiempos de ejecucin inferiores a 1ms, lo ideal es ejecutar el algoritmo un 
		// nmero alto de veces de forma que dicho nmero alto de veces produzca un tiempo de ejecucion
		// superior a 1ms  y dividir luego por ese nmero de veces.
	    final long numExperimentos = 10000000;
		
		// Vector que voy a utilizar para realizar mi experimento
		// Genero un ejemplar "aleatorio" para mi experimento
		// de tamao 5
		EnteroLento [] v = GeneraVectores.generaVectorOrdenado(100);
		
		// Genero un nmero aleatorio que puede estar o no estar en el vector
		EnteroLento e = GeneraVectores.generaEnteroAleatorio(0,101); 

		// Ejecuto el algoritmo un nmero alto de veces
		long tInicio = System.currentTimeMillis();
		for(int k=0;k<numExperimentos;k++) {
			Buscador.busquedaLineal(v, e);
		} // for
		long tFin = System.currentTimeMillis();
		long tiempoEmpleado = tFin - tInicio;
	
		// Ahora tendra que descontar al tiempo empleado por el algortimo de 
		// ordenacin el tiempo que ha tardado la carcasa usada para ejecutarlo 
		// un nmero alto de veces
		tInicio = System.currentTimeMillis();; 
		for(int k=0;k<numExperimentos;k++){
		} //  for
		tFin = System.currentTimeMillis();
		long tiempoCarcasa = tFin - tInicio;
		double tiempoUnidad = ((double)tiempoEmpleado - (double)tiempoCarcasa) / (double) numExperimentos; 
		System.out.println("El algoritmo tarda " + tiempoUnidad + " ms.");
		System.out.println("El algoritmo ms la carcasa en " + numExperimentos  + " ejecuciones tarda " + tiempoEmpleado + " ms.");
	}

} // Runner
